/*
 * sample.c
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "Profile.h"

/* Define */
#define MAIN_WND_CLASS			TEXT("SampleWndClass")
#define WINDOW_TITLE			TEXT("Sample Window")

#define IDC_EDIT				1

#define BUF_SIZE				256

/* Global Variables */
static HINSTANCE hInst;
static TCHAR ini_path[MAX_PATH];

static int win_left;
static int win_top;
static int win_width;
static int win_height;
static TCHAR text[BUF_SIZE];

/* Local Function Prototypes */
static void get_ini(HINSTANCE hInstance);
static void put_ini();

static LRESULT CALLBACK wnd_proc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
static BOOL init_application(HINSTANCE hInstance);
static HWND init_instance(HINSTANCE hInstance, int CmdShow);

/*
 * get_ini - ݒ̎擾
 */
static void get_ini(HINSTANCE hInstance)
{
	TCHAR *p, *r;

	// init@C̃pX擾
	GetModuleFileName(hInstance, ini_path, BUF_SIZE - 1);
	for (p = r = ini_path; *p != TEXT('\0'); p++) {
#ifndef UNICODE
		if (IsDBCSLeadByte((BYTE)*p) == TRUE) {
			p++;
			continue;
		}
#endif	// UNICODE
		if (*p == TEXT('\\')) {
			r = p;
		}
	}
	*r = TEXT('\0');
	lstrcat(ini_path, TEXT("\\sample.ini"));

	// inȉ
	profile_initialize(ini_path, TRUE);

	// ݒ̎擾
	// EBhETCY
	win_left = profile_get_int(TEXT("window"), TEXT("left"), 100, ini_path);
	win_top = profile_get_int(TEXT("window"), TEXT("top"), 100, ini_path);
	win_width = profile_get_int(TEXT("window"), TEXT("width"), 300, ini_path);
	win_height = profile_get_int(TEXT("window"), TEXT("height"), 100, ini_path);
	// eLXg
	profile_get_string(TEXT("edit"), TEXT("text"), TEXT(""), text, BUF_SIZE - 1, ini_path);

	// inỉ
	profile_free();
}

/*
 * put_ini - ݒ̕ۑ
 */
static void put_ini()
{
	// inȉ
	profile_initialize(ini_path, FALSE);

	// ݒ̕ۑ
	// EBhETCY
	profile_write_int(TEXT("window"), TEXT("left"), win_left, ini_path);
	profile_write_int(TEXT("window"), TEXT("top"), win_top, ini_path);
	profile_write_int(TEXT("window"), TEXT("width"), win_width, ini_path);
	profile_write_int(TEXT("window"), TEXT("height"), win_height, ini_path);
	// eLXg
	profile_write_string(TEXT("edit"), TEXT("text"), text, ini_path);

	// inȉ
	profile_flush(ini_path);
	// inỉ
	profile_free();
}

/*
 * wnd_proc - EBhEvV[W
 */
static LRESULT CALLBACK wnd_proc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	RECT rect;

	switch (msg) {
	case WM_CREATE:
		// EBhE쐬
		CreateWindowEx(WS_EX_CLIENTEDGE, TEXT("EDIT"), TEXT(""),
			WS_VISIBLE | WS_CHILD | ES_AUTOHSCROLL,
			0, 0, 0, 0,
			hWnd, (HMENU)IDC_EDIT, ((LPCREATESTRUCT)lParam)->hInstance, NULL);
		SendMessage(GetDlgItem(hWnd, IDC_EDIT), WM_SETTEXT, 0, (LPARAM)text);
		break;

	case WM_SETFOCUS:
		// tH[JX̐ݒ
		SetFocus(GetDlgItem(hWnd, IDC_EDIT));
		break;

	case WM_SIZE:
		// EBhẼTCYƕύX
		GetClientRect(hWnd, &rect);
		MoveWindow(GetDlgItem(hWnd, IDC_EDIT), 0, 0,
			rect.right, 30, TRUE);
		break;

	case WM_EXITSIZEMOVE:
		// EBhẼTCYƈʒu̕ύXI
		if (IsWindowVisible(hWnd) != 0 && IsIconic(hWnd) == 0 && IsZoomed(hWnd) == 0) {
			GetWindowRect(hWnd, (LPRECT)&rect);
			win_left = rect.left;
			win_top = rect.top;
			win_width = rect.right - rect.left;
			win_height = rect.bottom - rect.top;
		}
		break;

	case WM_ENDSESSION:
		// WindowsI
		SendMessage(GetDlgItem(hWnd, IDC_EDIT), WM_GETTEXT, BUF_SIZE - 1, (LPARAM)text);
		DestroyWindow(hWnd);
		return 0;

	case WM_CLOSE:
		// EBhE
		SendMessage(GetDlgItem(hWnd, IDC_EDIT), WM_GETTEXT, BUF_SIZE - 1, (LPARAM)text);
		DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
		// ݒ̕ۑ
		put_ini();
		// EBhEj
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}

/*
 * init_application - EBhENX̓o^
 */
static BOOL init_application(HINSTANCE hInstance)
{
	WNDCLASS wc;

	wc.style = 0;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.lpszMenuName = NULL;
	wc.lpfnWndProc = (WNDPROC)wnd_proc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = NULL;
	wc.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
	wc.lpszClassName = MAIN_WND_CLASS;
	// EBhENX̓o^
	return RegisterClass(&wc);
}

/*
 * init_instance - EBhE̍쐬
 */
static HWND init_instance(HINSTANCE hInstance, int CmdShow)
{
	HWND hWnd;

	// EBhE̍쐬
	hWnd = CreateWindow(MAIN_WND_CLASS,
		WINDOW_TITLE,
		WS_OVERLAPPEDWINDOW,
		win_left,
		win_top,
		win_width,
		win_height,
		NULL, NULL, hInstance, NULL);
	if (hWnd == NULL) {
		return NULL;
	}
	
	// EBhE̕\
	ShowWindow(hWnd, CmdShow);
	UpdateWindow(hWnd);
	return hWnd;
}

/*
 * WinMain - C
 */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	hInst = hInstance;

	// ݒ̎擾
	get_ini(hInstance);

	// EBhENX̓o^
	if (init_application(hInstance) == FALSE) {
		return 0;
	}
	// EBhE̍쐬
	if (init_instance(hInstance, nCmdShow) == NULL) {
		return 0;
	}
	// EBhEbZ[W
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
/* End of source */
